//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "dlgAddRm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TAddRemvDlg *AddRemvDlg;
//---------------------------------------------------------------------------

__fastcall TAddRemvDlg::TAddRemvDlg(TComponent* Owner)
	: TForm(Owner), FMove( false )
{
}
//---------------------------------------------------------------------------

void __fastcall TAddRemvDlg::btnAddClick(TObject *Sender)
{
	for ( int i = listSource->Items->Count - 1; i >= 0; i-- )
    	if ( ( listSource->Selected[i] )
        	&& ( listDest->Items->IndexOf( listSource->Items->Strings[i] ) == -1 ) )
        {
           	listDest->Items->Add( listSource->Items->Strings[i] );
        	if ( FMove )
            	listSource->Items->Delete( i );
        }
    if ( listDest->Items->Count )
    {
        btnRemove->Enabled = true;
    	btnRemAll->Enabled = true;
    }
    if ( !listSource->Items->Count )
    {
    	btnAdd->Enabled = false;
        btnAddAll->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TAddRemvDlg::btnAddAllClick(TObject *Sender)
{
	if ( !FMove )
    	listDest->Items->Clear( );
    listDest->Items->AddStrings( listSource->Items );
    if ( FMove )
    {
    	listSource->Items->Clear( );
        btnAdd->Enabled = false;
	    btnAddAll->Enabled = false;
    }
    btnRemove->Enabled = true;
    btnRemAll->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TAddRemvDlg::btnRemoveClick(TObject *Sender)
{
	for ( int i = listDest->Items->Count - 1; i >= 0; i-- )
    	if ( listDest->Selected[i] )
        {
        	if ( FMove )
            	listSource->Items->Add( listDest->Items->Strings[i] );
        	listDest->Items->Delete( i );
        }
    if ( listSource->Items->Count )
    {
    	btnAdd->Enabled = true;
        btnAddAll->Enabled = true;
    }
    if ( !listDest->Items->Count )
    {
    	btnRemove->Enabled = false;
        btnRemAll->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TAddRemvDlg::btnRemAllClick(TObject *Sender)
{
	if ( FMove )
	    listSource->Items->AddStrings( listDest->Items );
   	listDest->Items->Clear( );
    btnRemove->Enabled = false;
    btnRemAll->Enabled = false;
    btnAdd->Enabled = true;
   	btnAddAll->Enabled = true;
}
//---------------------------------------------------------------------------

